#!/bin/csh 

# Bias Correction Graphing Script
# Created by Bryan M. Williams on December 2, 2013

set start=$1
set end=$2
set step=$3
#set chan=$4

set nonomatch

set missing='-9999999.0'

#echo $start
#echo $end

set chr=0
set cdate=$start

set dir=`pwd`

source $dir/bc_config

set datestamp=`date +'%Y%m%d%H%M'`
set timestring=`date`

if(-e "dirlist.txt") then
  rm dirlist.txt
  echo "Old directory list deleted."
endif

while( $cdate <= $end )
  set yyyy=`echo $cdate | cut -c 1-4`
  set mm=`echo $cdate | cut -c 5-6`
  set dd=`echo $cdate | cut -c 7-8`
  set hh=`echo $cdate | cut -c 9-10`

  @ chr=$chr + $step
  set cdate=`./timestring.sh $start $chr`
  echo $GSI_DIR'/GSI_ANALYSIS.'$yyyy'_'$mm'_'$dd'_'$hh'_00/' >> dirlist.txt
end
# exit 0

#goto graph

foreach line ("`cat dirlist.txt`")
  set filedate=`echo $line | rev | cut -d'/' -f2 | rev`
# echo $filedate
  set fdate=`echo $filedate | cut -d'.' -f2`
# echo $fdate
  set yyyy=`echo $fdate | cut -d'_' -f1`
  set MM=`echo $fdate | cut -d'_' -f2`
  set dd=`echo $fdate | cut -d'_' -f3`
  set hh=`echo $fdate | cut -d'_' -f4`
  set date=${yyyy}${MM}${dd}${hh}
# echo $date

  cd $line

  if (! -e "fort.207" || ! -e $line) then
    echo "FATAL ERROR! File 'fort.207' not found. Script cannot continue."
    echo "Directory in config is: "$GSI_DIR
    echo "Line error at: "$line
    echo 'Please check the config file or date range.'
    cd $dir
    rm dirlist.txt
    rm *_it*.txt
    rm *_finalstats.txt
    exit 1
  endif

  if(-e "fort.207") then
     echo  "fort.207 found for date "$date". Reading it..."
     set it=1
     set itcomplete1=0
     set itcomplete2=0
     set itcomplete3=0
     set itcomplete4=0
     set itcomplete5=0
     #jd start
     if ( $CH1 < 10000 ) then
        set spaces1="[[:space:]]"
     endif
     if ( $CH1 < 1000 ) then
        set spaces1="[[:space:]][[:space:]]"
     endif
     if ( $CH1 < 100) then 
        set spaces1="[[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH1 < 10) then 
        set spaces1="[[:space:]][[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH2 < 10000 ) then
        set spaces2="[[:space:]]"
     endif
     if ( $CH2 < 1000 ) then
        set spaces2="[[:space:]][[:space:]]"
     endif
     if ( $CH2 < 100) then
        set spaces2="[[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH2 < 10) then
        set spaces2="[[:space:]][[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH3 < 10000 ) then
        set spaces3="[[:space:]]"
     endif
     if ( $CH3 < 1000 ) then
        set spaces3="[[:space:]][[:space:]]"
     endif
     if ( $CH3 < 100) then
        set spaces3="[[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH3 < 10) then
        set spaces3="[[:space:]][[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH4 < 10000 ) then
        set spaces4="[[:space:]]"
     endif
     if ( $CH4 < 1000 ) then
        set spaces4="[[:space:]][[:space:]]"
     endif
     if ( $CH4 < 100) then
        set spaces4="[[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH4 < 10) then
        set spaces4="[[:space:]][[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH5 < 10000 ) then
        set spaces5="[[:space:]]"
     endif
     if ( $CH5 < 1000 ) then
        set spaces5="[[:space:]][[:space:]]"
     endif
     if ( $CH5 < 100) then
        set spaces5="[[:space:]][[:space:]][[:space:]]"
     endif
     if ( $CH5 < 10) then
        set spaces5="[[:space:]][[:space:]][[:space:]][[:space:]]"
     endif

     rm -f $dir/matching_lines
     /bin/grep -e "^.....${spaces1}${CH1} ${OBS_TYPE}" fort.207 >> ${dir}/matching_lines # match lines starting with 6 arbitrary characters, followed by space followed by the channel number
     /bin/grep -e "^.....${spaces2}${CH2} ${OBS_TYPE}" fort.207 >> ${dir}/matching_lines # match lines starting with 6 arbitrary characters, followed by space followed by the channel number
     /bin/grep -e "^.....${spaces3}${CH3} ${OBS_TYPE}" fort.207 >> ${dir}/matching_lines # match lines starting with 6 arbitrary characters, followed by space followed by the channel number
     /bin/grep -e "^.....${spaces4}${CH4} ${OBS_TYPE}" fort.207 >> ${dir}/matching_lines # match lines starting with 6 arbitrary characters, followed by space followed by the channel number
     /bin/grep -e "^.....${spaces5}${CH5} ${OBS_TYPE}" fort.207 >> ${dir}/matching_lines # match lines starting with 6 arbitrary characters, followed by space followed by the channel number
     /bin/grep -e "^......................${INS_NAME}" fort.207 >> ${dir}/matching_lines
     #foreach row ("`cat $line/fort.207`")
     #  if(`echo $row | cut -d' ' -f3 -s` == $OBS_TYPE && `echo $row | cut -d' ' -f2 -s` == $chan) then
      
     set it1=1
     set it2=1
     set it3=1
     set it4=1
     set it5=1
     set itfinal=1

     set itcomplete1=0
     set itcomplete2=0
     set itcomplete3=0
     set itcomplete4=0
     set itcomplete5=0


     foreach row ( "`cat ${dir}/matching_lines`" )
     #jd end
         set chan=`echo $row | cut -d' ' -f2`
         set before=`echo $row | cut -d' ' -f7`
         set after=`echo $row | cut -d' ' -f8`
         set rms=`echo $row | cut -d' ' -f11` # Actually the standard deviation
         set used=`echo $row | cut -d' ' -f4`
         set tossed=`echo $row | cut -d' ' -f5`
#        echo "file "$it":"
#        echo "bias before correction: "$before
#        echo "bias after correction: "$after
#        echo "rms: "$rms
         if($chan == $CH1) then
#          echo $CH1' data found'
           echo $date" "$before" "$after" "$rms >> ${dir}/${OBS_TYPE}_ch${CH1}_it${it1}.txt
           echo $date" "$used" "$tossed >> ${dir}/${OBS_TYPE}_ch${CH1}_it${it1}_finalstats.txt
           @ it1=$it1 + 1
         else if($chan == $CH2) then
#          echo $CH2' data found'
           echo $date" "$before" "$after" "$rms >> ${dir}/${OBS_TYPE}_ch${CH2}_it${it2}.txt
           echo $date" "$used" "$tossed >> ${dir}/${OBS_TYPE}_ch${CH2}_it${it2}_finalstats.txt
           @ it2=$it2 + 1
         else if($chan == $CH3) then
#          echo $CH3' data found'
           echo $date" "$before" "$after" "$rms >> ${dir}/${OBS_TYPE}_ch${CH3}_it${it3}.txt
           echo $date" "$used" "$tossed >> ${dir}/${OBS_TYPE}_ch${CH3}_it${it3}_finalstats.txt
           @ it3=$it3 + 1
         else if($chan == $CH4) then
#          echo $CH4' data found'
           echo $date" "$before" "$after" "$rms >> ${dir}/${OBS_TYPE}_ch${CH4}_it${it4}.txt
           echo $date" "$used" "$tossed >> ${dir}/${OBS_TYPE}_ch${CH4}_it${it4}_finalstats.txt
           @ it4=$it4 + 1
         else if($chan == $CH5) then
#          echo $CH5' data found'
           echo $date" "$before" "$after" "$rms >> ${dir}/${OBS_TYPE}_ch${CH5}_it${it5}.txt
           echo $date" "$used" "$tossed >> ${dir}/${OBS_TYPE}_ch${CH5}_it${it5}_finalstats.txt
           @ it5=$it5 + 1
         else
           goto next
         endif

         next:

         if(`echo $row | cut -d' ' -f2` == '0'$itfinal && `echo $row | cut -d' ' -f4` == ${SAT_NAME} && `echo $row | cut -d' ' -f5` == ${INS_NAME}) then
           set read=`echo $row | cut -d' ' -f6`
           set keep=`echo $row | cut -d' ' -f7`
           set assim=`echo $row | cut -d' ' -f8`
           echo $date" "$read" "$keep" "$assim >> ${dir}/${OBS_TYPE}_it${itfinal}_finalstats.txt
           @ itfinal=$itfinal + 1
           if($itfinal == 4) then
             set itfinal=1
           endif
         endif

         if($it1 == 4) then
           set it1=1
           set itcomplete1=1
         endif

         if($it2 == 4) then
           set it2=1
           set itcomplete2=1
         endif

         if($it3 == 4) then
           set it3=1
           set itcomplete3=1
         endif

         if($it4 == 4) then
           set it4=1
           set itcomplete4=1
         endif

         if($it5 == 4) then
           set it5=1
           set itcomplete5=1
         endif

       #endif jd
     end

     echo "done."
#    date

     if($itcomplete1 == 1) then
       echo "All data found for "$date" channel "$CH1"."
     endif

     if($itcomplete2 == 1) then
       echo "All data found for "$date" channel "$CH2"."
     endif

     if($itcomplete3 == 1) then
       echo "All data found for "$date" channel "$CH3"."
     endif

     if($itcomplete4 == 1) then
       echo "All data found for "$date" channel "$CH4"."
     endif

     if($itcomplete5 == 1) then
       echo "All data found for "$date" channel "$CH5"."
     endif


     if($itcomplete1 == 0) then
       echo -n "Some data for "$date" channel "$CH1" not found. Iterations missing: "
       while($it1 != 4)
         echo -n $it1' '
         echo $date" "$missing" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH1}_it${it1}.txt
         echo $date" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH1}_it${it1}_finalstats.txt 
         @ it1=$it1 + 1
       end
         set it1=1
         echo " "
     endif

     if($itcomplete2 == 0) then
       echo -n "Some data for "$date" channel "$CH2" not found. Iterations missing: "
       while($it2 != 4)
         echo -n $it2' '
         echo $date" "$missing" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH2}_it${it2}.txt
         echo $date" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH2}_it${it2}_finalstats.txt
         @ it2=$it2 + 1
       end
         set it2=1
         echo " "
     endif

     if($itcomplete3 == 0) then
       echo -n "Some data for "$date" channel "$CH3" not found. Iterations missing: "
       while($it3 != 4)
         echo -n $it3' '
         echo $date" "$missing" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH3}_it${it3}.txt
         echo $date" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH3}_it${it3}_finalstats.txt
         @ it3=$it3 + 1
       end
         set it3=1
         echo " "
     endif

     if($itcomplete4 == 0) then
       echo -n "Some data for "$date" channel "$CH4" not found. Iterations missing: "
       while($it4 != 4)
         echo -n $it4' '
         echo $date" "$missing" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH4}_it${it4}.txt
         echo $date" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH4}_it${it4}_finalstats.txt
         @ it4=$it4 + 1
       end
         set it4=1
         echo " "
     endif

     if($itcomplete5 == 0) then
       echo -n "Some data for "$date" channel "$CH5" not found. Iterations missing: "
       while($it5 != 4)
         echo -n $it5' '
         echo $date" "$missing" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH5}_it${it5}.txt
         echo $date" "$missing" "$missing >> ${dir}/${OBS_TYPE}_ch${CH5}_it${it5}_finalstats.txt
         @ it5=$it5 + 1
       end
         set it5=1
         echo " "
     endif

  endif
end

#exit 0

echo "Creating graphs..."

cd $dir

#goto graph

# Calculate wavenumber if airs.

if($INS_NAME == "airs") then

  set pi=3.141592654
  foreach line ("`cat airs_281_chn.txt`")
    set wnchan=`echo $line | cut -d" " -f1`
    set lambda=`echo $line | cut -d" " -f3`

    if($wnchan == $CH1) then
      set wn1=$lambda
    endif

    if($wnchan == $CH2) then
      set wn2=$lambda 
    endif

    if($wnchan == $CH3) then
      set wn3=$lambda
    endif

    if($wnchan == $CH4) then
      set wn4=$lambda
    endif

    if($wnchan == $CH5) then
      set wn5=$lambda
    endif

  end
else
  set wn1="N/A"
  set wn2="N/A"
  set wn3="N/A"
  set wn4="N/A"
  set wn5="N/A"
endif

set it=1

calc:

set lines_bef1=0
set sum_bef1=0
set bias_bef1=0

set lines_aft1=0
set sum_aft1=0
set bias_aft1=0

set lines_rms1=0
set sum_rms1=0
set bias_rms1=0

#echo ${OBS_TYPE}'_ch'${CH1}'_it'${it}'.txt'
foreach line ("`cat ${dir}/${OBS_TYPE}_ch${CH1}_it${it}.txt`")

# bias bef1ore correction

  if(`echo $line | cut -d" " -f2` != $missing) then
    @ lines_bef1=$lines_bef1 + 1
    set curr=`echo $line | cut -d" " -f2`
    set sum_bef1=`echo "$sum_bef1 + $curr" | bc`
  endif

# bias aft1er correction

  if(`echo $line | cut -d" " -f3` != $missing) then
    @ lines_aft1=$lines_aft1 + 1
    set curr=`echo $line | cut -d" " -f3`
    set sum_aft1=`echo "$sum_aft1 + $curr" | bc`
  endif

# rms1

if(`echo $line | cut -d" " -f4` != $missing) then
    @ lines_rms1=$lines_rms1 + 1
    set curr=`echo $line | cut -d" " -f4`
    set sum_rms1=`echo "$sum_rms1 + $curr" | bc`
  endif

end

if($lines_bef1 != 0) then
  set bias_bef1=`echo "scale=8; $sum_bef1 / $lines_bef1" | bc`
else
  set bias_bef1=0
endif

if($lines_aft1 != 0) then
  set bias_aft1=`echo "scale=8; $sum_aft1 / $lines_aft1" | bc`
else
  set bias_aft1=0
endif

if($lines_rms1 != 0) then
  set bias_rms1=`echo "scale=8; $sum_rms1 / $lines_rms1" | bc`
else
  set bias_rms1=0
endif

set lines_bef2=0
set sum_bef2=0
set bias_bef2=0

set lines_aft2=0
set sum_aft2=0
set bias_aft2=0

set lines_rms2=0
set sum_rms2=0
set bias_rms2=0

#echo ${OBS_TYPE}'_ch'${CH2}'_it'${it}'.txt'
foreach line ("`cat ${dir}/${OBS_TYPE}_ch${CH2}_it${it}.txt`")

# bias before correction

  if(`echo $line | cut -d" " -f2` != $missing) then
    @ lines_bef2=$lines_bef2 + 1
    set curr=`echo $line | cut -d" " -f2`
    set sum_bef2=`echo "$sum_bef2 + $curr" | bc`
  endif

# bias after correction

  if(`echo $line | cut -d" " -f3` != $missing) then
    @ lines_aft2=$lines_aft2 + 1
    set curr=`echo $line | cut -d" " -f3`
    set sum_aft2=`echo "$sum_aft2 + $curr" | bc`
  endif

# rms

if(`echo $line | cut -d" " -f4` != $missing) then
    @ lines_rms2=$lines_rms2 + 1
    set curr=`echo $line | cut -d" " -f4`
    set sum_rms2=`echo "$sum_rms2 + $curr" | bc`
  endif

end

if($lines_bef2 != 0) then
  set bias_bef2=`echo "scale=8; $sum_bef2 / $lines_bef2" | bc`
else
  set bias_bef2=0
endif

if($lines_aft2 != 0) then
  set bias_aft2=`echo "scale=8; $sum_aft2 / $lines_aft2" | bc`
else
  set bias_aft2=0
endif

if($lines_rms2 != 0) then
  set bias_rms2=`echo "scale=8; $sum_rms2 / $lines_rms2" | bc`
else
  set bias_rms2=0
endif

set lines_bef3=0
set sum_bef3=0
set bias_bef3=0

set lines_aft3=0
set sum_aft3=0
set bias_aft3=0

set lines_rms3=0
set sum_rms3=0
set bias_rms3=0

#echo ${OBS_TYPE}'_ch'${CH3}'_it'${it}'.txt'
foreach line ("`cat ${dir}/${OBS_TYPE}_ch${CH3}_it${it}.txt`")

# bias before correction

  if(`echo $line | cut -d" " -f2` != $missing) then
    @ lines_bef3=$lines_bef3 + 1
    set curr=`echo $line | cut -d" " -f2`
    set sum_bef3=`echo "$sum_bef3 + $curr" | bc`
  endif

# bias after correction

  if(`echo $line | cut -d" " -f3` != $missing) then
    @ lines_aft3=$lines_aft3 + 1
    set curr=`echo $line | cut -d" " -f3`
    set sum_aft3=`echo "$sum_aft3 + $curr" | bc`
  endif

# rms

if(`echo $line | cut -d" " -f4` != $missing) then
    @ lines_rms3=$lines_rms3 + 1
    set curr=`echo $line | cut -d" " -f4`
    set sum_rms3=`echo "$sum_rms3 + $curr" | bc`
  endif

end

if($lines_bef3 != 0) then
  set bias_bef3=`echo "scale=8; $sum_bef3 / $lines_bef3" | bc`
else
  set bias_bef3=0
endif

if($lines_aft3 != 0) then
  set bias_aft3=`echo "scale=8; $sum_aft3 / $lines_aft3" | bc`
else
  set bias_aft3=0
endif

if($lines_rms3 != 0) then
  set bias_rms3=`echo "scale=8; $sum_rms3 / $lines_rms3" | bc`
else
  set bias_rms3=0
endif

set lines_bef4=0
set sum_bef4=0
set bias_bef4=0

set lines_aft4=0
set sum_aft4=0
set bias_aft4=0

set lines_rms4=0
set sum_rms4=0
set bias_rms4=0

#echo ${OBS_TYPE}'_ch'${CH4}'_it'${it}'.txt'
foreach line ("`cat ${dir}/${OBS_TYPE}_ch${CH4}_it${it}.txt`")

# bias before correction

  if(`echo $line | cut -d" " -f2` != $missing) then
    @ lines_bef4=$lines_bef4 + 1
    set curr=`echo $line | cut -d" " -f2`
    set sum_bef4=`echo "$sum_bef4 + $curr" | bc`
  endif

# bias after correction

  if(`echo $line | cut -d" " -f3` != $missing) then
    @ lines_aft4=$lines_aft4 + 1
    set curr=`echo $line | cut -d" " -f3`
    set sum_aft4=`echo "$sum_aft4 + $curr" | bc`
  endif

# rms

if(`echo $line | cut -d" " -f4` != $missing) then
    @ lines_rms4=$lines_rms4 + 1
    set curr=`echo $line | cut -d" " -f4`
    set sum_rms4=`echo "$sum_rms4 + $curr" | bc`
  endif

end

if($lines_bef4 != 0) then
  set bias_bef4=`echo "scale=8; $sum_bef4 / $lines_bef4" | bc`
else
  set bias_bef4=0
endif

if($lines_aft4 != 0) then
  set bias_aft4=`echo "scale=8; $sum_aft4 / $lines_aft4" | bc`
else
  set bias_aft4=0
endif

if($lines_rms4 != 0) then
  set bias_rms4=`echo "scale=8; $sum_rms4 / $lines_rms4" | bc`
else
  set bias_rms4=0
endif

set lines_bef5=0
set sum_bef5=0
set bias_bef5=0

set lines_aft5=0
set sum_aft5=0
set bias_aft5=0

set lines_rms5=0
set sum_rms5=0
set bias_rms5=0

#echo ${OBS_TYPE}'_ch'${CH5}'_it'${it}'.txt'
foreach line ("`cat ${dir}/${OBS_TYPE}_ch${CH5}_it${it}.txt`")

# bias before correction

  if(`echo $line | cut -d" " -f2` != $missing) then
    @ lines_bef5=$lines_bef5 + 1
    set curr=`echo $line | cut -d" " -f2`
    set sum_bef5=`echo "$sum_bef5 + $curr" | bc`
  endif

# bias after correction

  if(`echo $line | cut -d" " -f3` != $missing) then
    @ lines_aft5=$lines_aft5 + 1
    set curr=`echo $line | cut -d" " -f3`
    set sum_aft5=`echo "$sum_aft5 + $curr" | bc`
  endif

# rms

if(`echo $line | cut -d" " -f4` != $missing) then
    @ lines_rms5=$lines_rms5 + 1
    set curr=`echo $line | cut -d" " -f4`
    set sum_rms5=`echo "$sum_rms5 + $curr" | bc`
  endif

end

if($lines_bef5 != 0) then
  set bias_bef5=`echo "scale=8; $sum_bef5 / $lines_bef5" | bc`
else
  set bias_bef5=0
endif

if($lines_aft5 != 0) then
  set bias_aft5=`echo "scale=8; $sum_aft5 / $lines_aft5" | bc`
else
  set bias_aft5=0
endif

if($lines_rms5 != 0) then
  set bias_rms5=`echo "scale=8; $sum_rms5 / $lines_rms5" | bc`
else
  set bias_rms5=0
endif

if($it == 1) then
  goto graph1
else if($it == 2) then
  goto graph2
else
  goto graph3
endif

graph1:

cd $dir

echo "Drawing graphs..."

/misc/whome/Lisa.R.Bucci/grads-2.0.1.oga.1/Contents/grads -blcx "run grapher3_mplot.gs ${OBS_TYPE}_ch${CH1}_it1.txt ${OBS_TYPE}_ch${CH2}_it1.txt ${OBS_TYPE}_ch${CH3}_it1.txt ${OBS_TYPE}_ch${CH4}_it1.txt ${OBS_TYPE}_ch${CH5}_it1.txt $CH1 $CH2 $CH3 $CH4 $CH5 $start ${OBS_TYPE} 1 $missing $bias_bef1 $bias_aft1 $bias_rms1 $bias_bef2 $bias_aft2 $bias_rms2 $bias_bef3 $bias_aft3 $bias_rms3 $bias_bef4 $bias_aft4 $bias_rms4 $bias_bef5 $bias_aft5 $bias_rms5 ${OBS_TYPE}_it1_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH1}_it1_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH2}_it1_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH3}_it1_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH4}_it1_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH5}_it1_finalstats.txt $wn1 $wn2 $wn3 $wn4 $wn5 $RUN_NAME" >> log_it1.txt

set it=2
#echo 'IT set to '$it

goto calc

graph2:

/misc/whome/Lisa.R.Bucci/grads-2.0.1.oga.1/Contents/grads -blcx "run grapher3_mplot.gs ${OBS_TYPE}_ch${CH1}_it2.txt ${OBS_TYPE}_ch${CH2}_it2.txt ${OBS_TYPE}_ch${CH3}_it2.txt ${OBS_TYPE}_ch${CH4}_it2.txt ${OBS_TYPE}_ch${CH5}_it2.txt $CH1 $CH2 $CH3 $CH4 $CH5 $start ${OBS_TYPE} 2 $missing $bias_bef1 $bias_aft1 $bias_rms1 $bias_bef2 $bias_aft2 $bias_rms2 $bias_bef3 $bias_aft3 $bias_rms3 $bias_bef4 $bias_aft4 $bias_rms4 $bias_bef5 $bias_aft5 $bias_rms5 ${OBS_TYPE}_it2_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH1}_it2_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH2}_it2_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH3}_it2_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH4}_it2_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH5}_it2_finalstats.txt $wn1 $wn2 $wn3 $wn4 $wn5 $RUN_NAME" >> log_it2.txt

set it=3
#echo 'IT set to '$it

goto calc

graph3:

/misc/whome/Lisa.R.Bucci/grads-2.0.1.oga.1/Contents/grads -blcx "run grapher3_mplot.gs ${OBS_TYPE}_ch${CH1}_it3.txt ${OBS_TYPE}_ch${CH2}_it3.txt ${OBS_TYPE}_ch${CH3}_it3.txt ${OBS_TYPE}_ch${CH4}_it3.txt ${OBS_TYPE}_ch${CH5}_it3.txt $CH1 $CH2 $CH3 $CH4 $CH5 $start ${OBS_TYPE} 3 $missing $bias_bef1 $bias_aft1 $bias_rms1 $bias_bef2 $bias_aft2 $bias_rms2 $bias_bef3 $bias_aft3 $bias_rms3 $bias_bef4 $bias_aft4 $bias_rms4 $bias_bef5 $bias_aft5 $bias_rms5 ${OBS_TYPE}_it3_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH1}_it3_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH2}_it3_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH3}_it3_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH4}_it3_finalstats.txt ${dir}/${OBS_TYPE}_ch${CH5}_it3_finalstats.txt $wn1 $wn2 $wn3 $wn4 $wn5 $RUN_NAME" >> log_it3.txt

rm -r ./dirlist.txt

mkdir ${RUN_NAME}_${OBS_TYPE}_${start}_biascor/
mv ${OBS_TYPE}_ch*.txt ${RUN_NAME}_${OBS_TYPE}_${start}_biascor/
mv log_* ${RUN_NAME}_${OBS_TYPE}_${start}_biascor/
mv ${OBS_TYPE}_it*_finalstats.txt ${RUN_NAME}_${OBS_TYPE}_${start}_biascor/
mv biascor*.png ${RUN_NAME}_${OBS_TYPE}_${start}_biascor/

#mkdir ${start}_biascor_${RUN_NAME}_${OBS_TYPE}_${datestamp}
#mv ${OBS_TYPE}_ch*.txt ${start}_biascor_${RUN_NAME}_${OBS_TYPE}_${datestamp}/
#mv log_* ${start}_biascor_${RUN_NAME}_${OBS_TYPE}_${datestamp}/
#mv ${OBS_TYPE}_it*_finalstats.txt ${start}_biascor_${RUN_NAME}_${OBS_TYPE}_${datestamp}/
#mv biascor*.png ${start}_biascor_${RUN_NAME}_${OBS_TYPE}_${datestamp}/

exit 0
