## Domain Average File Generator

## Created by Bryan M. Williams on January 16, 2014

import os, getopt, glob, math, numpy, sys, time, shutil, subprocess as proc

### Function meanbias: takes a file and calculates the mean. ###

def meanbias(file):
        data = 0
        sum1 = 0
        avg = 0
        f = open(file, 'a+')
        for line in f:
#		print line
                L = line.split(' ')
                L1 = float(L[1])
                sum1 = sum1 + L1
                data = data + 1

        avg = sum1 / data
        f.close()
	avg = format(avg, '.6f')
        return (data, avg)

### Function meanRMS: takes a file and calculates the mean RMS. ###

def meanRMS(file):
        data = 0
        sum1 = 0
        avg = 0
        f = open(file, 'a+')
        for line in f:
#		print line
                L = line.split(' ')
                L2 = float(L[2])
                sum1 = sum1 + L2
                data = data + 1

        avg = sum1 / data
        f.close()
	avg = format(avg, '.6f')
        return (data, avg)

## Function da_WTF: writes domain average to file. (Note: WTF does *not* mean what you think it does. ;)) ###

def da_WTF(date, avg, rms, fname, domain, homedir):
	prevdir = os.getcwd()
#	print prevdir
#	print homedir
	os.chdir(homedir)
	os.chdir('domain_averages')

	da_name = fname + '_da_d0' + domain + '.txt'

	f = open(da_name, 'a+')

	f.write(str(date) + ' ' + str(avg) + ' ' + str(rms) + '\n')

	f.close()

	os.chdir(prevdir)

## 0. Check arguments.

homedir = os.getcwd()

# If a run isn't specified, notify user, and quit with code 1.

try:
	run = sys.argv[1]
except:
	print 'ERROR: Experiment not specified. Please specify an experiment.'
	quit(1)

# If a domain isn't specified, notify user, and quit with code 3.

try:
	domain = sys.argv[2]
except:
	print 'ERROR: Domain not specified. Please specify a domain number.'
	quit(3)

try:
	step = sys.argv[3]
except:
	print 'ERROR: Interval not specified. Please specify the interval between runs.'
	quit(2)

if step == 0:
	print 'ERROR: Step cannot equal zero.'
	quit(2)

# Open and read 'da_config' to get remaining arguments. If not found, quit with code 4.

L = []

try:
	for line in open('da_config', 'r'):
		L = line.split(' ')

		try:
			if L[1] == 'run':
				run_config = str(L[2])
				run_config = run_config.strip('\n\r')
			elif L[1] == 'level1':
				level1 = str(L[2])
				level1 = level1.strip('\n\r')
			elif L[1] == 'level2':
				level2 = str(L[2])
				level2 = level2.strip('\n\r')
			elif L[1] == 'level3':
				level3 = str(L[2])
				level3 = level3.strip('\n\r')
			else:
				continue
		except:
			continue
except:
	print 'ERROR: da_config not found.'
	quit(4)
	

# Change into Experiment directory. If directory not found, notify user and quit with code 2.

try:
	os.chdir(run)
	rundir = os.getcwd()
except:
	print 'ERROR: Experiment directory not found. Please check your spelling and try again.'
	quit(2)

if not os.path.exists('./domain_averages'): # Create domain_average directory inside run directory.
        os.makedirs('./domain_averages')

scripts = []

try:
	for script in glob.glob(r'../*da*.gs'):
		scripts.append(script)

#	print scripts	


	for script in scripts:
		shutil.copy(script, '.')
except:
	print 'ERROR: Scripts not found.'
	quit(6)

# run = 'EnKF_Control_d02'

#print scripts

#os.system('ls')

## 1. Create a list of directories and files.

print 'Reading directories...'

run_glob = './*' + run + '*' # Wildcards should ensure that all directories are found.

dirlist = [] # Empty List for directories

for dir in sorted(glob.glob(run_glob)):
 	D = dir.strip('./')
#	print D
	dirlist.append(D)

# print dirlist

datelist = []
curdate = ''
prevdate = '0'

for dir in dirlist: # Create a list of directories.
	D = dir.split('_')
	curdate = D[0]

	if curdate != prevdate:
		datelist.append(curdate)
		prevdate = curdate

# print datelist

#sys.exit()

print 'Reading files...'

#print dirlist

curhr = 0

for dir in dirlist:
	filelist = []

	D1 = dir.split('_')
	curdate = D1[0]

#	print 'Working date ' + str(curdate) + ' ' + domain + '...'
#	A = os.getcwd()
#	print A
	os.chdir(dir)
#	os.getcwd()
	os.chdir('dsets')
#	os.getcwd()
	for file in os.listdir('.'):
		filelist.append(file)

#	print filelist

#	sys.exit()

	for data in filelist:
#		print filelist
# 		print data
		D2 = data.split('_')
		if D2[0] == 'MSLP':
			dataname = 'MSLP'
		elif D2[1] == '10m':
			if D2[0] == 'uwind':
				dataname = 'uwind_10m'
			elif D2[0] == 'vwind':
				dataname = 'vwind_10m'
			elif D2[0] == 'wind':
				dataname = 'wind_10m'
			else:
				pass
		else:
			dataname = D2[0] + '_' + D2[1] + 'mb'

#		print dataname

		T1 = meanbias(data)
		T2 = meanRMS(data)
		avg = T1[1]
		avgrms = T2[1]

#		print dataname
		da_WTF(curhr, avg, avgrms, dataname, domain, rundir)

	os.chdir(rundir)

	curhr = curhr + int(step)

#		print 'Domain Average for ' + str(dataname) + ' in folder ' + dir + ': ' + str(avg)
#		print 'RMS Domain Average for ' + str(dataname) + ' in folder ' + dir + ': ' + str(avgrms)

# print filelist

# quit()
#		sys.exit()

print "Graphing Domain averages..."

finalhr = curhr - int(step)

for file in glob.glob("domain_averages/*.txt"):
#	print file
	shutil.copy(file, '.')

cmd = str(run) + ' ' + str(level1) + ' ' + str(level2) + ' ' + str(level3) + ' ' + str(domain) + ' ' + '0' + ' ' + str(step) + ' ' + str(finalhr)

#print cmd

rc = proc.call('/misc/whome/Lisa.R.Bucci/grads-2.0.1.oga.1/Contents/grads -blcx "run graph_da_mplot.gs ' + cmd + '" >> log_dagraph_d0' + domain + ".txt", shell=True)

try:
	for file in glob.glob('*_da_*.png'):
		shutil.move(file, './domain_averages')
except:
	for file in glob.glob('*_da_*.png'):
		print 'Another graphic with the same name is located in the folder. The new one will be renamed "."'

for file in glob.glob('*da_*'):
	os.remove(file)

os.chdir(homedir)

#	os.getcwd()
	
