* Line graph creator for MSLP (for MPlot)
* Created by: Bryan M. Williams on September 1,3 2013

Function main(args)
data=subwrd(args,1)
start_date=subwrd(args,2)
channel=subwrd(args,3)
obs=subwrd(args,4)
it=subwrd(args,5)
bias_bef=subwrd(args,6)
bias_aft=subwrd(args,7)
bias_rms=subwrd(args,8)
rms_bef=subwrd(args,9)
rms_aft=subwrd(args,10)
rms_rms=subwrd(args,11)
missing=subwrd(args,12)

* Pre-Script Tasks

'reinit'
'set display color white'
'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=7.8
pylo=1.5
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=8.1
pxhi_l=10.9
pylo_l=2.1
pyhi_l=5.5

yint=1
xlab='Date'
ylab='Observation'
title1='Bias Correction (channel 'channel')'
title2=data

BEFmarktype=2
BEFmarksize=0.09
BEFlcolor=2
BEFlstyle=1
BEFlthick=6

AFTmarktype=2
AFTmarksize=0.09
AFTlcolor=3
AFTlstyle=1
AFTlthick=6

RMSmarktype=8
RMSmarksize=0.09
RMSlcolor=4
RMSlstyle=1
RMSlthick=6

*xmin=0
*xmax=60
*ymin=-1.5
*ymax=1.5

* Draw Graph Area.

say 'Drawing graph area...'

'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=1000
ymax=0
xmin=0
xmax=0
olddate=0
res=read(data)
rc=sublin(res,1)
first=1
while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  if(first & yval != missing)
    ymin=yval
    ymax=yval
    firstdate=date
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif
 
  if(date != olddate)
    check=date-olddate
    if(check >= 100)
      xmax=xmax+4
    endif
    if(check < 100)
      xmax=xmax+2
    endif
    olddate = date
    lastx=0
  endif

  if(date = olddate)
    lastx=lastx+1
  endif 

  res=read(data)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data)

say ymin

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.1f',ymin) - 1
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

ymax=math_format('%.2f',ymax) + 1

*say xdif' = ('pxhi' - 'pxlo')/('xmax' - 'xmin')'

xmax=(xmax-15)*6
xint=10

xdif = (pxhi - pxlo)/(xmax - xmin)
ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20 bl 2 0'
  'set strsiz 0.10 0.12'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.0f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (date)...'

xx = xmin
olddatestr=0
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read(data)
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  datestr=subwrd(res,2)
  if(datestr >= firstdate & datestr != olddatestr)
    mon=substr(datestr,5,2)
    day=substr(datestr,7,2)
    hr=substr(datestr,9,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y1=pylo-0.55
    x1=x-0.05
    y2=pylo-0.28
    'draw line 'x' 'pylo' 'x' 'ya
    if(hr = 00)
*      say 'plotting... 'mon'-'day' 'hr'Z'
      'draw string 'x1' 'y1' 'mon'-'day' 'hr'Z'
    endif
    if(hr = 12)
*      say 'plotting... 'hr'Z'
      'draw string 'x' 'y2' 'hr'Z'
    endif
    xx = xx + xint
    olddatestr = datestr
  endif
  res = read(data)
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close(data)

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res = read(data)
rc = sublin(res,1)
xtime=0

while (rc=0)

  before = subwrd(res,3)
  after = subwrd(res,4)
  rms = subwrd(res,5)

  x = xtime
  y1 = before
  y2 = after
  y3 = rms

*  say x
*  say y1
*  say y2
*  say y3

  x = pxlo+(x-xmin)*xdif
  if(y1 != missing)
    y1 = pylo+(y1-ymin)*ydif
  endif

  if(y2 != missing)
    y2 = pylo+(y2-ymin)*ydif
  endif

  if(y3 != missing)
    y3 = pylo+(y3-ymin)*ydif
  endif

*  say 'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick

  'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y1' 'BEFmarksize

*  say 'set line 'AFTlcolor' 'AFTlstyle' 'AFTlthick

  'set line 'AFTlcolor' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y2' 'AFTmarksize

*  say 'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick

  'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
* 'draw mark 'RMSmarktype' 'x' 'y3' 'RMSmarksize

  if(first)
*    say 'Inside if statement'

    if(y1 != missing)    
      'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick
      'draw line 'xold' 'y1old' 'x' 'y1
    endif

    if(y2 != missing)
      'set line 'AFTlcolor' 'AFTlstyle' 'AFTlthick
      'draw line 'xold' 'y2old' 'x' 'y2
    endif

    if(y3 != missing)
      'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
      'draw line 'xold' 'y3old' 'x' 'y3
    endif
  endif

  first = 1

* if(y1 != missing)  
    xold = x
* endif

 if(y1 != missing)
    y1old = y1
 endif

 if(y2 != missing)
    y2old = y2
 endif

 if(y3 != missing)
    y3old = y3
 endif

  xtime = xtime + xint

  res = read(data)

  rc = sublin(res,1)

endwhile

mid=(pxhi+pxlo)/2
midy=(pyhi+pylo)/2

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 0.3 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.5 'midy' 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 8.3 'title1
'draw string 'mid' 7.9 'title2

*return

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

mid_l=(pxhi_l+pxlo_l)/2

'set strsiz 0.15'
'set string 1 bl 0 0'

'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.05' Before Correction'

'set line 'AFTlcolor' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'AFTlcolor' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-0.45' After Correction'

'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty-0.8' 'RMSmarksize
'draw string 'startx+0.40' 'starty-0.85' RMS'

'set string 1 c 1 0'
'draw string 'mid_l' 'pyhi_l+0.2' KEY'

'run displayer.gs 'startx' 'starty' 'bias_bef' 'bias_aft' 'bias_rms' 'rms_bef' 'rms_aft' 'rms_rms

'printim biascor_'start_date'_'obs'_ch'channel'_it'it'.png x1600 y1200'
 

say 'Done. Graph completed.'
