* Line graph creator for Bias Correction (version 3)
* Created by: Bryan M. Williams on December 6, 2013

Function main(args)
data1=subwrd(args,1)
start_date=subwrd(args,2)
obs=subwrd(args,3)
it=subwrd(args,4)
missing=subwrd(args,5)

* Pre-Script Tasks

*'reinit'
*'set display color white'
*'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=7
pylo=2.5
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=8.1
pxhi_l=10.9
pylo_l=2.5
pyhi_l=6.5

yint=60000
xlab='Date'
ylab='# of Data * 10`a4`n'
title1='Final Summary of Observation Data'
title2='+ = read `3K`0 = kept `3M`0 = assimilated'

color1=1
color2=1
color3=1

RMSlstyle=1
RMSlthick=6

READmarktype=1
READmarksize=0.09

KEEPmarktype=4
KEEPmarksize=0.09

ASSIMmarktype=8
ASSIMmarksize=0.09

*xmin=0
*xmax=60
*ymin=-1.5
*ymax=1.5

* Draw Graph Area.

say 'Drawing graph area...'

'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=10000
ymax=-10000
xmin=0
xmax=0
olddate=0
res=read(data1)
rc=sublin(res,1)
first=1
while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  if(first & yval != missing)
    ymin=yval
    ymax=yval
    firstdate=date
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  if(date != olddate)
    check=date-olddate
    if(check >= 100)
      xmax=xmax+4
    endif
    if(check < 100)
      xmax=xmax+2
    endif
    olddate = date
    lastx=0
  endif

  if(date = olddate)
    lastx=lastx+1
  endif 

  res=read(data1)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data1)

say ymin' 'ymax

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.2f',ymin) - yint
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

if(ymin = 0)
  ymin=-yint
endif

ymax=math_format('%.2f',ymax) + yint

*say xdif' = ('pxhi' - 'pxlo')/('xmax' - 'xmin')'

xmax=(xmax-15)*6
xint=10

xdif = (pxhi - pxlo)/(xmax - xmin)
ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20 bl 2 0'
  'set strsiz 0.10 0.12'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.2f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy/10000)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (date)...'

xx = xmin
olddatestr=0
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read(data1)
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  datestr=subwrd(res,2)
  if(datestr >= firstdate & datestr != olddatestr)
    mon=substr(datestr,5,2)
    day=substr(datestr,7,2)
    hr=substr(datestr,9,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y1=pylo-0.55
    x1=x-0.05
    y2=pylo-0.28
    'draw line 'x' 'pylo' 'x' 'ya
    if(hr = 00)
*      say 'plotting... 'mon'-'day' 'hr'Z'
      'draw string 'x1' 'y1' 'mon'-'day' 'hr'Z'
    endif
    if(hr = 12)
*      say 'plotting... 'hr'Z'
      'draw string 'x' 'y2' 'hr'Z'
    endif
    xx = xx + xint
    olddatestr = datestr
  endif
  res = read(data1)
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close(data1)

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res1 = read(data1)

rc = sublin(res1,1)
xtime=0

while (rc=0)

  nread = subwrd(res1,3)
  nkeep = subwrd(res1,4)
  nassim = subwrd(res1,5)

  x = xtime
  y1 = nread
  y2 = nkeep
  y3 = nassim
  
*  say y2
*  say x
*  say y1
*  say y2
*  say y3

  x = pxlo+(x-xmin)*xdif

  if(y1 != missing)
    y1 = pylo+(y1-ymin)*ydif
  endif

  if(y2 != missing)
    y2 = pylo+(y2-ymin)*ydif
  endif

  if(y3 != missing)
    y3 = pylo+(y3-ymin)*ydif
  endif

  'set line 'color1' 'RMSlstyle' 'RMSlthick
  'draw mark 'READmarktype' 'x' 'y1' 'READmarksize

  'set line 'color2' 'RMSlstyle' 'RMSlthick
  'draw mark 'KEEPmarktype' 'x' 'y2' 'KEEPmarksize

  'set line 'color3' 'RMSlstyle' 'RMSlthick
  'draw mark 'ASSIMmarktype' 'x' 'y3' 'ASSIMmarksize

  if(first)
*    say 'Inside if statement'

    if(y1 != missing)    
      'set line 'color1' 'RMSlstyle' 'RMSlthick
*     say 'y1b draw line 'xold' 'y1bold' 'x' 'y1b
*     'draw line 'xold' 'y1old' 'x' 'y1
    endif

    if(y2 != missing)
      'set line 'color2' 'RMSlstyle' 'RMSlthick
*     say 'y2b draw line 'xold' 'y2bold' 'x' 'y2b
*     'draw line 'xold' 'y2old' 'x' 'y2
    endif

    if(y3 != missing)
      'set line 'color3' 'RMSlstyle' 'RMSlthick
*     say 'y3b draw line 'xold' 'y3bold' 'x' 'y3b
*     'draw line 'xold' 'y3old' 'x' 'y3
    endif

  endif

  first = 1

 xold = x

 if(y1 != missing)
    y1old = y1
 endif

 if(y2 != missing)
    y2old = y2
 endif

 if(y3 != missing)
    y3old = y3
 endif

  xtime = xtime + xint

  res1 = read(data1)
  rc = sublin(res1,1)

endwhile

*return

mid=(pxhi+pxlo)/2
midy=(pyhi+pylo)/2

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 1.3 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.3 'midy' 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 8.3 'title1
'draw string 'mid' 7.9 'title2

return

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

mid_l=(pxhi_l+pxlo_l)/2

'set strsiz 0.1'
'set string 1 bl 0 0'

'set line 'color1' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'color1' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.05' 'tch1

'set line 'color2' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'color2' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty-0.4' 'RMSmarksize
'draw string 'startx+0.40' 'starty-0.45' 'tch2

'set line 'color3' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'set line 'color3' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.85' 'tch3

'set line 'color4' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-1.2' 'startx+0.3' 'starty-1.2
'set line 'color4' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty-0.4' 'RMSmarksize
'draw string 'startx+0.40' 'starty-1.25' 'tch4

'set line 'color5' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-1.6' 'startx+0.3' 'starty-1.6
'set line 'color5' 'RMSlstyle' 'RMSlthick
*'draw mark 'RMSmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-1.65' 'tch5

'set string 1 c 1 0'
'draw string 'mid_l' 'pyhi_l+0.2' KEY'

*'run displayer.gs 'startx' 'starty' 'bias_bef' 'bias_aft' 'bias_rms' 'rms_bef' 'rms_aft' 'rms_rms

*return

*'printim biascor_rms_'start_date'_'obs'_ch'channel'_it'it'.png x1600 y1200'
 

say 'Done. Graph completed.'
