* Line graph creator for Bias Correction (version 3)
* Created by: Bryan M. Williams on December 6, 2013

Function main(args)
data1=subwrd(args,1)
data2=subwrd(args,2)
data3=subwrd(args,3)
data4=subwrd(args,4)
data5=subwrd(args,5)
tch1=subwrd(args,6)
tch2=subwrd(args,7)
tch3=subwrd(args,8)
tch4=subwrd(args,9)
tch5=subwrd(args,10)
start_date=subwrd(args,11)
obs=subwrd(args,12)
it=subwrd(args,13)
missing=subwrd(args,14)
bef_data1=subwrd(args,15)
aft_data1=subwrd(args,16)
rms_data1=subwrd(args,17)
bef_data2=subwrd(args,18)
aft_data2=subwrd(args,19)
rms_data2=subwrd(args,20)
bef_data3=subwrd(args,21)
aft_data3=subwrd(args,22)
rms_data3=subwrd(args,23)
bef_data4=subwrd(args,24)
aft_data4=subwrd(args,25)
rms_data4=subwrd(args,26)
bef_data5=subwrd(args,27)
aft_data5=subwrd(args,28)
rms_data5=subwrd(args,29)
finalstats=subwrd(args,30)
finaldata1=subwrd(args,31)
finaldata2=subwrd(args,32)
finaldata3=subwrd(args,33)
finaldata4=subwrd(args,34)
finaldata5=subwrd(args,35)
wn1=subwrd(args,36)
wn2=subwrd(args,37)
wn3=subwrd(args,38)
wn4=subwrd(args,39)
wn5=subwrd(args,40)
name=subwrd(args,41)

* Pre-Script Tasks

'reinit'
'set display color white'
'run font.gs 3'
'c'

** GRAPHING **

'set string 2 bl 0 0'
'set strsiz 0.1 0.12'
'draw string 0 8.3 'obs
'draw string 0 8.1 'name

say 'Graphing Bias correction...'

'set vpage 0 3.42 4.3 7.8'
'run grapher3_panel.gs 'data1' 'data2' 'data3' 'data4' 'data5' 'tch1' 'tch2' 'tch3' 'tch4' 'tch5' 'start_date' 'obs' 'it' 'missing

say 'Graphing variance...'

'set vpage 3.67 7.09 4.3 7.8'
'run grapher3_rms_panel.gs 'data1' 'data2' 'data3' 'data4' 'data5' 'tch1' 'tch2' 'tch3' 'tch4' 'tch5' 'start_date' 'obs' 'it' 'missing

say 'Graphing used v. tossed...'

'set vpage 7.34 11 4.3 7.8'
'run grapher3_finalch_panel.gs 'finaldata1' 'finaldata2' 'finaldata3' 'finaldata4' 'finaldata5' 'tch1' 'tch2' 'tch3' 'tch4' 'tch5' 'start_date' 'obs' 'it' 'missing

say 'graphing final summary...'

'set vpage 3.67 7.09 0 3.5'
'run grapher3_final_panel.gs 'finalstats' 'start_date' 'obs' 'it' 'missing

'set vpage off'

*** Create a legend (key), x- and y-axis label, and title. ***

'set vpage off'
'set string 1 c 0 0'
'set strsiz 0.1 0.12'

ch1=1.1
ch2=3.3
ch3=5.5
ch4=7.7
ch5=9.9

diff=0.6

str_y=4.6

'set string 1'
'set ccolor 1'
'set line 1 1 4'

'draw string 'ch1' 'str_y' Channel 'tch1
'draw string 'ch1' 'str_y-0.2' `3l`0 = 'wn1
'draw line 'ch1-diff' 'str_y-0.3' 'ch1+diff' 'str_y-0.3

'draw string 'ch2' 'str_y' Channel 'tch2
'draw string 'ch2' 'str_y-0.2' `3l`0 = 'wn2
'draw line 'ch2-diff' 'str_y-0.3' 'ch2+diff' 'str_y-0.3

'draw string 'ch3' 'str_y' Channel 'tch3
'draw string 'ch3' 'str_y-0.2' `3l`0 = 'wn3
'draw line 'ch3-diff' 'str_y-0.3' 'ch3+diff' 'str_y-0.3

'draw string 'ch4' 'str_y' Channel 'tch4
'draw string 'ch4' 'str_y-0.2' `3l`0 = 'wn4
'draw line 'ch4-diff' 'str_y-0.3' 'ch4+diff' 'str_y-0.3

'draw string 'ch5' 'str_y' Channel 'tch5
'draw string 'ch5' 'str_y-0.2' `3l`0 = 'wn5
'draw line 'ch5-diff' 'str_y-0.3' 'ch5+diff' 'str_y-0.3

'set string 1 bl 0 0'
'set strsiz 0.08 0.12'


'draw string 'ch1-1.5*diff' 'str_y-0.5' Mean Before = 'bef_data1
'draw string 'ch1-1.5*diff' 'str_y-0.7' Mean After = 'aft_data1
'draw string 'ch1-1.5*diff' 'str_y-0.9' `3s`0 = 'rms_data1

'draw string 'ch2-1.5*diff' 'str_y-0.5' Bias Before = 'bef_data2
'draw string 'ch2-1.5*diff' 'str_y-0.7' Bias After = 'aft_data2
'draw string 'ch2-1.5*diff' 'str_y-0.9' `3s`0 = 'rms_data2

'draw string 'ch3-1.5*diff' 'str_y-0.5' Bias Before = 'bef_data3
'draw string 'ch3-1.5*diff' 'str_y-0.7' Bias After = 'aft_data3
'draw string 'ch3-1.5*diff' 'str_y-0.9' `3s`0 = 'rms_data3

'draw string 'ch4-1.5*diff' 'str_y-0.5' Bias Before = 'bef_data4
'draw string 'ch4-1.5*diff' 'str_y-0.7' Bias After = 'aft_data4
'draw string 'ch4-1.5*diff' 'str_y-0.9' `3s`0 = 'rms_data4

'draw string 'ch5-1.5*diff' 'str_y-0.5' Bias Before = 'bef_data5
'draw string 'ch5-1.5*diff' 'str_y-0.7' Bias After = 'aft_data5
'draw string 'ch5-1.5*diff' 'str_y-0.9' `3s`0 = 'rms_data5


* Draw box where key will go.

pxlo_l=2.5
pxhi_l=7.7
pylo_l=8.0
pyhi_l=8.4

color1=2
color2=3
color3=4
color4=12
color5=9

marktype=2
marksize=0.09
lstyle=1
lthick=6

int=0.2

'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

mid_l=(pxhi_l+pxlo_l)/2
ly_mid=(pyhi_l+pylo_l)/2

'set strsiz 0.1 0.12'
'set string 1 bl 0 0'

'set line 'color1' 'lstyle' 'lthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'color1' 'lstyle' 'lthick
*'draw mark 'marktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.05' 'tch1

'set line 'color3' 'lstyle' 'lthick
'draw line 'startx+2' 'starty' 'startx+2.3' 'starty
'set line 'color3' 'lstyle' 'lthick
*'draw mark 'marktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+2.40' 'starty-0.05' 'tch3

'set line 'color5' 'lstyle' 'lthick
'draw line 'startx+4.2' 'starty' 'startx+4.5' 'starty
'set line 'color5' 'lstyle' 'lthick
*'draw mark 'marktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+4.60' 'starty-0.05' 'tch5

'set line 'color2' 'lstyle' 'lthick
'draw line 'startx+0.9' 'starty' 'startx+1.2' 'starty
'set line 'color2' 'lstyle' 'lthick
*'draw mark 'marktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+1.30' 'starty-0.05' 'tch2

'set line 'color4' 'lstyle' 'lthick
'draw line 'startx+3.1' 'starty' 'startx+3.4' 'starty
'set line 'color4' 'lstyle' 'lthick
*'draw mark 'marktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+3.50' 'starty-0.05' 'tch4

'set string 1 c 1 0'
'draw string 'pxlo_l-0.2' 'ly_mid' KEY'

*'run displayer.gs 'startx' 'starty' 'bias_bef' 'bias_aft' 'bias_rms' 'rms_bef' 'rms_aft' 'rms_rms

*return

'printim biascor_'start_date'_'obs'_ch'channel'_it'it'.png x1600 y1200'
 

say 'Done. Graph completed.'
