* Line graph creator for Bias Correction (version 3)
* Created by: Bryan M. Williams on December 6, 2013

Function main(args)
data1=subwrd(args,1)
data2=subwrd(args,2)
data3=subwrd(args,3)
data4=subwrd(args,4)
data5=subwrd(args,5)
tch1=subwrd(args,6)
tch2=subwrd(args,7)
tch3=subwrd(args,8)
tch4=subwrd(args,9)
tch5=subwrd(args,10)
start_date=subwrd(args,11)
obs=subwrd(args,12)
it=subwrd(args,13)
missing=subwrd(args,14)

* Pre-Script Tasks

*'reinit'
*'set display color white'
*'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=7
pylo=2.5
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=8.1
pxhi_l=10.9
pylo_l=2.5
pyhi_l=6.5

yint=1
xlab='Date'
ylab='TB Error (K)'
title1='Bias Correction'
title2='(Before = dashed, after = solid)'

color1=2
color2=3
color3=4
color4=12
color5=9

BEFmarktype=2
BEFmarksize=0.09
BEFlstyle=7
BEFlthick=6

AFTmarktype=2
AFTmarksize=0.09
AFTlstyle=1
AFTlthick=6

*xmin=0
*xmax=60
*ymin=-1.5
*ymax=1.5

* Draw Graph Area.

say 'Drawing graph area...'

'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=10000
ymax=-10000
xmin=0
xmax=0
olddate=0
res=read(data1)
rc=sublin(res,1)
first=1

while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  if(first & yval != missing)
    ymin=yval
    ymax=yval
    firstdate=date
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif
 
  if(date != olddate)
    check=date-olddate
    if(check >= 100)
      xmax=xmax+4
    endif
    if(check < 100)
      xmax=xmax+2
    endif
    olddate = date
    lastx=0
  endif

  if(date = olddate)
    lastx=lastx+1
  endif 

  res=read(data1)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data1)
res=read(data2)
rc=sublin(res,1)

while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  res=read(data2)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data2)
res=read(data3)
rc=sublin(res,1)

while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  res=read(data3)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data3)
res=read(data4)
rc=sublin(res,1)

while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  res=read(data4)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data4)
res=read(data5)
rc=sublin(res,1)

while(rc=0)
  date=subwrd(res,2)
  yval=subwrd(res,3)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval & yval != missing)
    ymax=yval
  endif
  if(yval < ymin & yval != missing)
    ymin=yval
  endif

  res=read(data5)
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close(data5)

say ymin

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.1f',ymin) - (yint/2)
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

if(ymin = 0)
  ymin=-yint
endif

ymax=math_format('%.2f',ymax) + (yint/2)

*Fixed ymin and ymax (Comment out if unneeded)

ymin=-3
ymax=4

**********************************************

*say xdif' = ('pxhi' - 'pxlo')/('xmax' - 'xmin')'

xmax=(xmax-15)*6
xint=10

xdif = (pxhi - pxlo)/(xmax - xmin)
ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20 bl 2 0'
  'set strsiz 0.10 0.12'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.0f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (date)...'

xx = xmin
olddatestr=0
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read(data1)
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  datestr=subwrd(res,2)
  if(datestr >= firstdate & datestr != olddatestr)
    mon=substr(datestr,5,2)
    day=substr(datestr,7,2)
    hr=substr(datestr,9,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y1=pylo-0.55
    x1=x-0.05
    y2=pylo-0.28
    'draw line 'x' 'pylo' 'x' 'ya
    if(hr = 00)
*      say 'plotting... 'mon'-'day' 'hr'Z'
      'draw string 'x1' 'y1' 'mon'-'day' 'hr'Z'
    endif
    if(hr = 12)
*      say 'plotting... 'hr'Z'
      'draw string 'x' 'y2' 'hr'Z'
    endif
    xx = xx + xint
    olddatestr = datestr
  endif
  res = read(data1)
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close(data1)

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res1 = read(data1)
res2 = read(data2)
res3 = read(data3)
res4 = read(data4)
res5 = read(data5)

rc = sublin(res1,1)
xtime=0

while (rc=0)

  before1 = subwrd(res1,3)
  after1 = subwrd(res1,4)

  before2 = subwrd(res2,3)
  after2 = subwrd(res2,4)

  before3 = subwrd(res3,3)
  after3 = subwrd(res3,4)

  before4 = subwrd(res4,3)
  after4 = subwrd(res4,4)

  before5 = subwrd(res5,3)
  after5 = subwrd(res5,4)

  x = xtime
  y1b = before1
  y1a = after1

  y2b = before2
  y2a = after2

  y3b = before3
  y3a = after3

  y4b = before4
  y4a = after4

  y5b = before5
  y5a = after5
  

*  say x
*  say y1
*  say y2a' 'y2b
*  say y3

  x = pxlo+(x-xmin)*xdif

  if(y1b != missing)
    y1b = pylo+(y1b-ymin)*ydif
  endif

  if(y1a != missing)
    y1a = pylo+(y1a-ymin)*ydif
  endif

  if(y2b != missing)
    y2b = pylo+(y2b-ymin)*ydif
  endif

  if(y2a != missing)
    y2a = pylo+(y2a-ymin)*ydif
  endif

  if(y3b != missing)
    y3b = pylo+(y3b-ymin)*ydif
  endif

  if(y3a != missing)
    y3a = pylo+(y3a-ymin)*ydif
  endif

  if(y4b != missing)
    y4b = pylo+(y4b-ymin)*ydif
  endif

  if(y4a != missing)
    y4a = pylo+(y4a-ymin)*ydif
  endif

  if(y5b != missing)
    y5b = pylo+(y5b-ymin)*ydif
  endif

  if(y5a != missing)
    y5a = pylo+(y5a-ymin)*ydif
  endif



*  say 'set line 'BEFlcolor' 'BEFlstyle' 'BEFlthick

  'set line 'color1' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y1b' 'BEFmarksize

  'set line 'color1' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y1a' 'AFTmarksize

 'set line 'color2' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y2b' 'BEFmarksize

  'set line 'color2' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y2a' 'AFTmarksize

 'set line 'color3' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y3b' 'BEFmarksize

  'set line 'color3' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y3a' 'AFTmarksize

 'set line 'color4' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y4b' 'BEFmarksize

  'set line 'color4' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y4a' 'AFTmarksize

 'set line 'color5' 'BEFlstyle' 'BEFlthick
* 'draw mark 'BEFmarktype' 'x' 'y5b' 'BEFmarksize

  'set line 'color5' 'AFTlstyle' 'AFTlthick
* 'draw mark 'AFTmarktype' 'x' 'y5a' 'AFTmarksize


  if(first)
*    say 'Inside if statement'

    if(y1b != missing)    
      'set line 'color1' 'BEFlstyle' 'BEFlthick
*     say 'y1b draw line 'xold' 'y1bold' 'x' 'y1b
      'draw line 'xold' 'y1bold' 'x' 'y1b
    endif

    if(y1a != missing)
      'set line 'color1' 'AFTlstyle' 'AFTlthick
*     say 'y1a draw line 'xold' 'y1aold' 'x' 'y1a
      'draw line 'xold' 'y1aold' 'x' 'y1a
    endif

    if(y2b != missing)
      'set line 'color2' 'BEFlstyle' 'BEFlthick
*     say 'y2b draw line 'xold' 'y2bold' 'x' 'y2b
      'draw line 'xold' 'y2bold' 'x' 'y2b
    endif

    if(y2a != missing)
      'set line 'color2' 'AFTlstyle' 'AFTlthick
*     say 'y2a draw line 'xold' 'y2aold' 'x' 'y2a
      'draw line 'xold' 'y2aold' 'x' 'y2a
    endif

    if(y3b != missing)
      'set line 'color3' 'BEFlstyle' 'BEFlthick
*     say 'y3b draw line 'xold' 'y3bold' 'x' 'y3b
      'draw line 'xold' 'y3bold' 'x' 'y3b
    endif

    if(y3a != missing)
      'set line 'color3' 'AFTlstyle' 'AFTlthick
*     say 'y3a draw line 'xold' 'y3aold' 'x' 'y3a
      'draw line 'xold' 'y3aold' 'x' 'y3a
    endif

    if(y4b != missing)
      'set line 'color4' 'BEFlstyle' 'BEFlthick
*     say 'y4b draw line 'xold' 'y4bold' 'x' 'y4b
      'draw line 'xold' 'y4bold' 'x' 'y4b
    endif

    if(y4a != missing)
      'set line 'color4' 'AFTlstyle' 'AFTlthick
*     say 'y4a draw line 'xold' 'y4aold' 'x' 'y4a
      'draw line 'xold' 'y4aold' 'x' 'y4a
    endif

    if(y5b != missing)
      'set line 'color5' 'BEFlstyle' 'BEFlthick
*     say 'y5b draw line 'xold' 'y5bold' 'x' 'y5b
      'draw line 'xold' 'y5bold' 'x' 'y5b
    endif

    if(y5a != missing)
      'set line 'color5' 'AFTlstyle' 'AFTlthick
*     say 'y5a draw line 'xold' 'y5aold' 'x' 'y5a
      'draw line 'xold' 'y5aold' 'x' 'y5a
    endif

  endif

  first = 1

 xold = x

 if(y1b != missing)
    y1bold = y1b
 endif

 if(y1a != missing)
    y1aold = y1a
 endif

 if(y2b != missing)
    y2bold = y2b
 endif

 if(y2a != missing)
    y2aold = y2a
 endif

 if(y3b != missing)
    y3bold = y3b
 endif

 if(y3a != missing)
    y3aold = y3a
 endif

 if(y4b != missing)
    y4bold = y4b
 endif

 if(y4a != missing)
    y4aold = y4a
 endif

 if(y5b != missing)
    y5bold = y5b
 endif

 if(y5a != missing)
    y5aold = y5a
 endif

  xtime = xtime + xint

  res1 = read(data1)
  res2 = read(data2)
  res3 = read(data3)
  res4 = read(data4)
  res5 = read(data5)

  rc = sublin(res1,1)

endwhile

*return

mid=(pxhi+pxlo)/2
midy=(pyhi+pylo)/2

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 1.3 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.5 'midy' 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 8.3 'title1
'draw string 'mid' 7.9 'title2

return

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

mid_l=(pxhi_l+pxlo_l)/2

'set strsiz 0.1'
'set string 1 bl 0 0'

'set line 'color1' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'color1' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.05' Before Corr. ch. 'tch1

'set line 'color1' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'color1' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-0.45' After Corr. ch. 'tch1

'set line 'color2' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'set line 'color2' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-0.85' Before Corr. ch. 'tch2

'set line 'color2' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-1.2' 'startx+0.3' 'starty-1.2
'set line 'color2' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-1.25' After Corr. ch. 'tch2

'set line 'color3' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty-1.6' 'startx+0.3' 'starty-1.6
'set line 'color3' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-1.65' Before Corr. ch. 'tch3

'set line 'color3' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-2.0' 'startx+0.3' 'starty-2.0
'set line 'color3' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-2.05' After Corr. ch. 'tch3

'set line 'color4' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty-2.4' 'startx+0.3' 'starty-2.4
'set line 'color4' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-2.45' Before Corr. ch. 'tch4

'set line 'color4' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-2.8' 'startx+0.3' 'starty-2.8
'set line 'color4' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-2.85' After Corr. ch. 'tch4

'set line 'color5' 'BEFlstyle' 'BEFlthick
'draw line 'startx' 'starty-3.2' 'startx+0.3' 'starty-3.2
'set line 'color5' 'BEFlstyle' 'BEFlthick
*'draw mark 'BEFmarktype' 'startx+0.15' 'starty' 'BEFmarksize
'draw string 'startx+0.40' 'starty-3.25' Before Corr. ch. 'tch5

'set line 'color5' 'AFTlstyle' 'AFTlthick
'draw line 'startx' 'starty-3.6' 'startx+0.3' 'starty-3.6
'set line 'color5' 'AFTlstyle' 'AFTlthick
*'draw mark 'AFTmarktype' 'startx+0.15' 'starty-0.4' 'AFTmarksize
'draw string 'startx+0.40' 'starty-3.65' After Corr. ch. 'tch5

'set string 1 c 1 0'
'draw string 'mid_l' 'pyhi_l+0.2' KEY'

*'run displayer.gs 'startx' 'starty' 'bias_bef' 'bias_aft' 'bias_rms' 'rms_bef' 'rms_aft' 'rms_rms

*return

*'printim biascor_'start_date'_'obs'_ch'channel'_it'it'.png x1600 y1200'
 

say 'Done. Graph completed.'
